﻿using Monkee.Interface.GUI;
using Styx.Common;
using Styx.WoWInternals;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Media;
using OV = Monkee.Interface.GUI.frmOverlay;

namespace Monkee.Core.Managers
{
    class Hotkeys
    {
        public static bool aoeOn { get; set; }
        public static bool cooldownsOn { get; set; }
        public static bool manualOn { get; set; }
        public static bool keysRegistered { get; set; }
        public static bool preBuff { get; set; }
        public static bool SEF { get; set; }
        public static event EventHandler hotkeyStateChanged;

        private static void OnHotkeyStateChange(EventArgs args){
            EventHandler handler = hotkeyStateChanged;
            if(handler != null)
                handler(null, args);
        }

        #region [Method] - Hotkey Registration
        public static void registerHotKeys()
        {
            if (keysRegistered)
                return;
            Hotkey hotkey = getHotkey(Main.Settings.hotkeyAOE);
            HotkeysManager.Register("aoeOn", (Keys)hotkey.key, (ModifierKeys)hotkey.mod, ret =>
            {
                aoeOn = !aoeOn;
                OnHotkeyStateChange(null);
                Lua.DoString(aoeOn ? @"print('AoE Mode: \124cFF15E61C Enabled!')" : @"print('AoE Mode: \124cFFE61515 Disabled!')");
            });
            hotkey = getHotkey(Main.Settings.hotkeyBurst);
            HotkeysManager.Register("cooldownsOn", (Keys)hotkey.key, (ModifierKeys)hotkey.mod, ret =>
            {
                cooldownsOn = !cooldownsOn;
                OnHotkeyStateChange(null);
                Lua.DoString(cooldownsOn ? @"print('Burst Mode: \124cFF15E61C Enabled!')" : @"print('Burst Mode: \124cFFE61515 Disabled!')");
            });
            hotkey = getHotkey(Main.Settings.hotkeyManual);
            HotkeysManager.Register("manualOn", (Keys)hotkey.key, (ModifierKeys)hotkey.mod, ret =>
            {
                manualOn = !manualOn;
                OnHotkeyStateChange(null);
                Lua.DoString(manualOn ? @"print('Manual Mode: \124cFF15E61C Enabled!')" : @"print('Manual Mode: \124cFFE61515 Disabled!')");
            });
            hotkey = getHotkey(Main.Settings.hotkeyPreBuff);
            HotkeysManager.Register("preBuff", (Keys)hotkey.key, (ModifierKeys)hotkey.mod, ret =>
            {
                preBuff = !preBuff;
                OnHotkeyStateChange(null);
                Lua.DoString(preBuff ? @"print('Pre Buffing: \124cFF15E61C Enabled!')" : @"print('Pre Buffing: \124cFFE61515 Disabled!')");
            });
            hotkey = getHotkey(Main.Settings.hotkeySEF);
            HotkeysManager.Register("SEF", (Keys)hotkey.key, (ModifierKeys)hotkey.mod, ret =>
            {
                SEF = !SEF;
                OnHotkeyStateChange(null);
                Lua.DoString(SEF ? @"print('SEF: \124cFF15E61C Enabled!')" : @"print('SEF: \124cFFE61515 Disabled!')");
            });

            keysRegistered = true;
            Lua.DoString(@"print('Hotkeys: \124cFF15E61C Registered!')");
            Logging.Write(Colors.OrangeRed, "Hotkeys: Registered!");
        }

        public static Hotkey getHotkey(string p)
        {
            string[] arr =  p.Split('|');
            Hotkey hotkey = new Hotkey();
            hotkey.key = int.Parse(arr[0]);
            hotkey.mod = int.Parse(arr[1]);
            return hotkey;
        }  
        #endregion

        #region [Method] - Hotkey Removal
        public static void removeHotkeys()
        {
            if (!keysRegistered)
                return;
            HotkeysManager.Unregister("aoeOn");
            HotkeysManager.Unregister("cooldownsOn");
            HotkeysManager.Unregister("manualOn");
            HotkeysManager.Unregister("preBuff");
            HotkeysManager.Unregister("overlay");
            aoeOn = false;
            cooldownsOn = false;
            manualOn = false;
            preBuff = false;
            SEF = false;
            keysRegistered = false;

            Lua.DoString(@"print('Hotkeys: \124cFFE61515 Removed!')");
            Logging.Write(Colors.OrangeRed, "Hotkeys: Removed!");
        }
        #endregion
        public struct Hotkey {
            public int key;
            public int mod;
        }
    }
}
