﻿using Styx;
using Styx.CommonBot;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using L = Monkee.Core.Utilities.Log;
namespace Monkee.Core.Managers
{
    public class initTMEvents
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        public static event EventHandler specChanged;
        public static bool
        #region 15 lvl
            celerity = false,
            tigersLust = false,
            momentum = false,
        #endregion

        #region 30 lvl
            chiWave = false,
            zenSphere = false,
            chiBurst = false,
        #endregion

        #region 45 lvl
            powerStrikes = false,
            ascension = false,
            chiBrew = false,
        #endregion

        #region 60 lvl
            ringOfPeace = false,
            chargingOxWave = false,
            legSweep = false,
        #endregion

        #region 75 lvl
            healingElixirs = false,
            dampenHarm = false,
            diffuseMagic = false,
        #endregion

        #region 90 lvl
            rushingJadeWind = false,
            invokeXuenTheWhiteTiger = false,
            chiTorpedo = false,
        #endregion

        #region 100 lvl
            soulDance = false,
            breathOfTheSerpent = false,
            hurricaneStrike = false,
            poolOfMists = false,
            chiExplosion = false,
            serenity = false;
        #endregion

        private static void onSpecChanged(EventArgs args){
            EventHandler handler = specChanged;
            if (handler != null) {
                handler(null, args);
            }
        }

        public static void initTalents()
        {
            if (Me.Level == 100 && Me.GetLearnedTalents().Count() != 7)
                return;

            celerity = Me.GetLearnedTalent(0).Index == 0;
            tigersLust = Me.GetLearnedTalent(0).Index == 1;
            momentum = Me.GetLearnedTalent(0).Index == 2;

            chiWave = Me.GetLearnedTalent(1).Index == 0;
            zenSphere = Me.GetLearnedTalent(1).Index == 1;
            chiBurst = Me.GetLearnedTalent(1).Index == 2;

            powerStrikes = Me.GetLearnedTalent(2).Index == 0;
            ascension = Me.GetLearnedTalent(2).Index == 1;
            chiBrew = Me.GetLearnedTalent(2).Index == 2;

            ringOfPeace = Me.GetLearnedTalent(3).Index == 0;
            chargingOxWave = Me.GetLearnedTalent(3).Index == 1;
            legSweep = Me.GetLearnedTalent(3).Index == 2;

            healingElixirs = Me.GetLearnedTalent(4).Index == 0;
            dampenHarm = Me.GetLearnedTalent(4).Index == 1;
            diffuseMagic = Me.GetLearnedTalent(4).Index == 2;

            rushingJadeWind = Me.GetLearnedTalent(5).Index == 0;
            invokeXuenTheWhiteTiger = Me.GetLearnedTalent(5).Index == 1;
            chiTorpedo = Me.GetLearnedTalent(5).Index == 2;

            hurricaneStrike = Me.GetLearnedTalent(6).Index == 0;
            chiExplosion = Me.GetLearnedTalent(6).Index == 1;
            serenity = Me.GetLearnedTalent(6).Index == 2;

            //soulDance = Me.GetLearnedTalent(6).Index == 0;
            //breathOfTheSerpent = Me.GetLearnedTalent(6).Index == 1;
            //poolOfMists = Me.GetLearnedTalent(7).Index == 0;

            
            L.combatLog("Selected talents:");
            if(celerity)
                printTalent("Celerity",1);
            else if(tigersLust)
                printTalent("Tiger's Lust",1);
            else if(momentum)
                printTalent("Momentum",1);

            if(chiWave)
                printTalent("Chi Wave", 2);
            else if(zenSphere)
                printTalent("Zen Sphere", 2);
            else if(chiBurst)
                printTalent("Chi Burst", 2);

            if(powerStrikes)
                printTalent("Power Strikes", 3);
            else if(ascension)
                printTalent("Ascension", 3);
            else if(chiBrew)
                printTalent("Chi Brew", 3);

            if (ringOfPeace)
                printTalent("Ring of Peace", 4);
            else if (chargingOxWave)
                printTalent("Charging Ox Wave", 4);
            else if (legSweep) 
                printTalent("Leg Sweep", 4);

            if (healingElixirs)
                printTalent("Healing Elixirs", 5);
            else if (dampenHarm)
                printTalent("Dampen Harm", 5);
            else if(diffuseMagic)
                printTalent("Diffuse Magic", 5);

            if (rushingJadeWind)
                printTalent("Rushing Jade Wind", 6);
            else if (invokeXuenTheWhiteTiger)
                printTalent("Invoke Xuen, The White Tiger", 6);
            else if(chiTorpedo)
                printTalent("Chi Torpedo", 6);

            if (hurricaneStrike)
                printTalent("Hurricane Strike", 7);
            else if (chiExplosion)
                printTalent("Chi Explosion", 7);
            else if(serenity)
                printTalent("Serenity", 7);
            
        }



        public static void setTalEvents() {
            Lua.Events.AttachEvent("CHARACTER_POINTS_CHANGED", updateTalentManager);
            //Lua.Events.AttachEvent("GLYPH_UPDATED", UpdateTalentManager);
            Lua.Events.AttachEvent("ACTIVE_TALENT_GROUP_CHANGED", talentSpecChanged);
        }

        private static void talentSpecChanged(object sender, LuaEventArgs args)
        {
            //TODO: Remove after all 3 Spec supported
            L.combatLog("Spec changed to {0}.", Me.Specialization);
            //onSpecChanged(args);
        }

        private static void printTalent(string name, int tier){
            L.combatLog("Tier {0}: {1}", tier, name);
        }

        private static void updateTalentManager(object sender, LuaEventArgs args)
        {
            L.combatLog("Talents changed...");
            initTalents();
        }
    }
}
