﻿using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
#region [Method] - Class Redundancy
using SB = Monkee.Core.Helpers.SpellBook;
using HkM = Monkee.Core.Managers.Hotkeys;
using L = Monkee.Core.Utilities.Log;
using OV = Monkee.Interface.GUI.frmOverlay;
using System.Collections;
using Styx.CommonBot.CharacterManagement;
using System.Timers;
using System.Diagnostics;
#endregion
namespace Monkee.Core
{
    static class Unit
    {

        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }
        enum Weapon { Fist = 0, Axe, Sword, Mace, Staff, Polearm };
        public static Stopwatch combatTime = new Stopwatch();  
        #region [Method] - Active Enemies
        public static IEnumerable<WoWUnit> activeEnemies(WoWPoint fromLocation, double Range)
        {
            IEnumerable<WoWUnit> Hostile = enemyCount;
            Hostile = Hostile != null ? Hostile.Where(x => x.Location.DistanceSqr(fromLocation) < Range * Range &&  x.Attackable && !x.IsCritter && !x.IsPetBattleCritter) : null;
            return Hostile;
        }

              
        private static List<WoWUnit> enemyCount { get; set; }

        public static void enemyAnnex(double Range)
        {
            enemyCount.Clear();
            foreach (var u in surroundingEnemies())
            {
                if (u == null || !u.IsValid)
                    continue;
                if (!u.IsAlive || u.DistanceSqr > Range * Range)
                    continue;
                if (!u.Attackable || !u.CanSelect)
                    continue;
                if (u.IsFriendly)
                    continue;
                if (u.IsNonCombatPet && u.IsCritter)
                    continue;
                enemyCount.Add(u);
            }
        }

        private static IEnumerable<WoWUnit> surroundingEnemies() { return ObjectManager.GetObjectsOfTypeFast<WoWUnit>(); }

        static Unit() { enemyCount = new List<WoWUnit>(); }  
        #endregion

        #region [Method] - Aura Detection


        public static bool auraExists(this WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return false;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in auraExists(): ", xException);
                return false;
            }
        }
  
        public static uint auraStacks(this WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return 0;                
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null ? Aura.StackCount : 0;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in auraStacks(): ", xException);
                return 0;
            }
        }

        public static double auraTimeLeft(this WoWUnit Unit, int auraID, bool isMyAura = false)
        {
            try
            {
                if (Unit == null || !Unit.IsValid)
                    return 0;
                WoWAura Aura = isMyAura ? Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID && A.CreatorGuid == Me.Guid) : Unit.GetAllAuras().FirstOrDefault(A => A.SpellId == auraID);
                return Aura != null ? Aura.TimeLeft.TotalMilliseconds : 0;
            }
            catch (Exception xException)
            {
                L.diagnosticLog("Exception in auraTimeLeft(): ", xException);
                return 9999;
            }
        }

        public static bool needToBuffMe() {
            bool param = true;
            bool crit = true;
            int[] aurasParam = { 1126, 159988, 115921, 116781, 160017, 20217, 90363, 160206, 160077, 69378 };
            int[] aurasCrit = { 17007, 90309, 1459, 61316, 126373, 116781, 160052, 160200, 90363, 126309, 24604 };
            foreach (int aura in aurasParam) {
                if (auraExists(Me, aura)) {
                    param = false;
                    break;
                }
            }
            foreach (int aura in aurasCrit)
            {
                if (auraExists(Me, aura))
                {
                    crit = false;
                    break;
                }
            }
            return param | crit;
        }
        #endregion

        #region [Method] - Cache

        public static uint chi;
        public static uint energy;
        public static uint stacksTEB;
        public static bool tigerEyeBrewUp;
        public static bool tigerPower;
        public static bool mortalWounds;
        public static bool risingSunKick;
        public static uint chiBrewStacks;
        public static bool serenityUp;
        public static float energyRegen;
        public static bool maxChiReached;
        public static uint maxChi;

        public static void Cache() {
            if (Me.Combat && !combatTime.IsRunning)
                combatTime.Start();
            else if(!Me.Combat){
                combatTime.Stop();
                combatTime.Reset();
            }

            chi = Me.CurrentChi;
            energy = Me.CurrentEnergy;
            stacksTEB = auraStacks(Me, SB.auraTigerEyeBrewSt);
            tigerPower = auraExists(Me, SB.auraTigerPower);
            mortalWounds = auraExists(currentTarget, SB.auraMortalWounds);
            risingSunKick = auraExists(currentTarget, SB.auraRisingSunKick);
            chiBrewStacks = auraStacks(Me, SB.spellChiBrew);
            tigerEyeBrewUp = auraExists(Me, SB.auraTigerEyeBrew);
            serenityUp = auraExists(Me, SB.auraSerenity);
            energyRegen = Lua.GetReturnVal<float>("return GetPowerRegen()", 1);
            maxChi = Me.MaxChi;
            setJab();
            maxChiReached = Me.MaxChi == Me.CurrentChi ? true : false;
        }

        private static void setJab()
        {
            if(Me.Inventory.Equipped.MainHand.ItemInfo.WeaponClass == WoWItemWeaponClass.Axe)
                    SB.setSpellJabId((int)Weapon.Axe);
            else if(Me.Inventory.Equipped.MainHand.ItemInfo.WeaponClass == WoWItemWeaponClass.Fist)
                    SB.setSpellJabId((int)Weapon.Fist);
            else if(Me.Inventory.Equipped.MainHand.ItemInfo.WeaponClass == WoWItemWeaponClass.Mace)
                    SB.setSpellJabId((int)Weapon.Mace);
            else if(Me.Inventory.Equipped.MainHand.ItemInfo.WeaponClass == WoWItemWeaponClass.Sword)
                    SB.setSpellJabId((int)Weapon.Sword);
            else if(Me.Inventory.Equipped.MainHand.ItemInfo.WeaponClass == WoWItemWeaponClass.Staff)
                    SB.setSpellJabId((int)Weapon.Staff);
            else if(Me.Inventory.Equipped.MainHand.ItemInfo.WeaponClass == WoWItemWeaponClass.Polearm)
                    SB.setSpellJabId((int)Weapon.Polearm);
        }

        public static bool energyCapped(uint time)
        {
            if ((energy + (energyRegen * time)) < Me.MaxEnergy)
            {
                //L.diagnosticLog("FALSE " + currentEnergy + " + (" + currentEnergyRegen + " * " + time + ") < " + Me.MaxEnergy);
                return false;
            }
            else
            {
                //L.diagnosticLog("TRUE " + currentEnergy + " + (" + currentEnergyRegen + " * " + time + ") < " + Me.MaxEnergy);
                return true;
            }
        }

        #region Singular Code
        public static bool IsCrowdControlled(this WoWUnit unit)
        {
            Dictionary<string, WoWAura>.ValueCollection auras = unit.Auras.Values;

            #if AURAS_HAVE_MECHANICS
                        return auras.Any(
                            a => a.Spell.Mechanic == WoWSpellMechanic.Banished ||
                                 a.Spell.Mechanic == WoWSpellMechanic.Charmed ||
                                 a.Spell.Mechanic == WoWSpellMechanic.Horrified ||
                                 a.Spell.Mechanic == WoWSpellMechanic.Incapacitated ||
                                 a.Spell.Mechanic == WoWSpellMechanic.Polymorphed ||
                                 a.Spell.Mechanic == WoWSpellMechanic.Sapped ||
                                 a.Spell.Mechanic == WoWSpellMechanic.Shackled ||
                                 a.Spell.Mechanic == WoWSpellMechanic.Asleep ||
                                 a.Spell.Mechanic == WoWSpellMechanic.Frozen ||
                                 a.Spell.Mechanic == WoWSpellMechanic.Invulnerable ||
                                 a.Spell.Mechanic == WoWSpellMechanic.Invulnerable2 ||
                                 a.Spell.Mechanic == WoWSpellMechanic.Turned ||

                                 // Really want to ignore hexed mobs.
                                 a.Spell.Name == "Hex"

                                 );
            #else
                        return unit.Stunned
                            || unit.Rooted
                            || unit.Fleeing
                            || unit.HasAuraWithEffect(
                                    WoWApplyAuraType.ModConfuse,
                                    WoWApplyAuraType.ModCharm,
                                    WoWApplyAuraType.ModFear,
                            // WoWApplyAuraType.ModDecreaseSpeed, 
                                    WoWApplyAuraType.ModPacify,
                                    WoWApplyAuraType.ModPacifySilence,
                                    WoWApplyAuraType.ModPossess,
                                    WoWApplyAuraType.ModRoot,
                                    WoWApplyAuraType.ModStun);
            #endif
        }

        // this one optimized for single applytype lookup
        public static bool HasAuraWithEffect(this WoWUnit unit, WoWApplyAuraType applyType)
        {
            return unit.Auras.Values.Any(a => a.Spell != null && a.Spell.SpellEffects.Any(se => applyType == se.AuraType));
        }

        public static bool HasAuraWithEffect(this WoWUnit unit, params WoWApplyAuraType[] applyType)
        {
            var hashes = new HashSet<WoWApplyAuraType>(applyType);
            return unit.Auras.Values.Any(a => a.Spell != null && a.Spell.SpellEffects.Any(se => hashes.Contains(se.AuraType)));
        }
        #endregion

        public static double timeToMaxEnergy() {
            return (Me.MaxEnergy - Me.CurrentEnergy) * energyRegen * 1000;
        }

        #endregion

        #region [Method] - Unit Evaluation
        //Validates Target
        public static bool isUnitValid(this WoWUnit Unit, double Range)
        {
            return Unit != null && Unit.IsValid && Unit.IsAlive && Unit.Attackable && Unit.DistanceSqr <= Range * Range;
        }
        #endregion
    }
}
