﻿using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using HkM = Monkee.Core.Managers.Hotkeys;
namespace Monkee.Interface.GUI
{
    public partial class frmOverlay : Form
    {
        private static frmOverlay overlay;
        private static bool shown;
        private bool mouseIsDown = false;
        private Point firstPoint;
        public static event EventHandler onLocationChanged;
        public ushort meleeState { get; set; }  //0 - no target, 1 - melee, 2- not melee
        public frmOverlay()
        {
            InitializeComponent();
            SetStyle(ControlStyles.SupportsTransparentBackColor, true);
            this.BackColor = Color.Black;
            TransparencyKey = Color.Black;
            lblMain.Text = "Monkee v." + Main.version+"b";
        }


        public static void updateLabels()
        {
            if (overlay == null)
                return;
            if (HkM.aoeOn)
            {
                overlay.lblAoE.Text = "AoE: ON";
                overlay.lblAoE.ForeColor = Color.LightGreen;
            }
            else
            {
                overlay.lblAoE.Text = "AoE: OFF";
                overlay.lblAoE.ForeColor = Color.Red;
            }
            if (HkM.cooldownsOn)
            {
                overlay.lblCoold.Text = "Burst: ON";
                overlay.lblCoold.ForeColor = Color.LightGreen;
            }
            else
            {
                overlay.lblCoold.Text = "Burst: OFF";
                overlay.lblCoold.ForeColor = Color.Red;
            }
            if (HkM.manualOn)
            {
                overlay.lblManual.Text = "Manual: ON";
                overlay.lblManual.ForeColor = Color.LightGreen;
            }
            else
            {
                overlay.lblManual.Text = "Manual: OFF";
                overlay.lblManual.ForeColor = Color.Red;
            }
            if (HkM.preBuff)
            {
                overlay.lblPreBuff.Text = "PreBuff: ON";
                overlay.lblPreBuff.ForeColor = Color.LightGreen;
            }
            else
            {
                overlay.lblPreBuff.Text = "PreBuff: OFF";
                overlay.lblPreBuff.ForeColor = Color.Red;
            }
            if (HkM.SEF)
            {
                overlay.lblSEF.Text = "SEF: ON";
                overlay.lblSEF.ForeColor = Color.LightGreen;
            }
            else
            {
                overlay.lblSEF.Text = "SEF: OFF";
                overlay.lblSEF.ForeColor = Color.Red;
            }
            switch(overlay.meleeState){
                case 0:
                    overlay.lblRange.Text = "Range: No target";
                    overlay.lblRange.ForeColor = Color.White;
                    break;
                case 1:
                    overlay.lblRange.Text = "Range: Melee";
                    overlay.lblRange.ForeColor = Color.YellowGreen;
                    break;
                case 2:
                    overlay.lblRange.Text = "Range: Not melee";
                    overlay.lblRange.ForeColor = Color.Red;
                    break;
                case 3:
                    overlay.lblRange.Text = "Range: Friendly target";
                    overlay.lblRange.ForeColor = Color.LightGreen;
                    break;
                default: 
                    overlay.lblRange.Text = "Range: No target";
                    overlay.lblRange.ForeColor = Color.White;
                    break;
            
            }
        }

        public static bool showOverlay(Point p)
        {
            overlay = new frmOverlay();
            overlay.Location = new Point(p.X, p.Y);
            overlay.Show();
            shown = true;
            return shown;
        }

        private static void onLocationChange(EventArgs args)
        {
            EventHandler handler = onLocationChanged;
            if (handler != null)
            {
                handler(null, args);
            }
        
        }

        public static void closeOverlay()
        {
            overlay.Close();
            shown = false;
        }

        public static void setLocation(Point p){
            if(p != null)
                overlay.Location = p;
        }

        public static Point getLocation() {
                return overlay.Location;
        }

        public static bool updateRange(WoWUnit target)
        {
            if (target == null || !target.IsValid)
                overlay.meleeState = 0;
            else if (target.IsFriendly)
                overlay.meleeState = 3;
            else if (target.IsWithinMeleeRange)
                overlay.meleeState = 1;
            else if (!target.IsWithinMeleeRange)
                overlay.meleeState = 2;
               
            return false;
        }



        public static bool isShown()
        {

            return (overlay != null && shown) ? true : false;
        }

        private void lblMain_MouseDown(object sender, MouseEventArgs e)
        {
            firstPoint = e.Location;
            mouseIsDown = true;
        }

        private void lblMain_MouseUp(object sender, MouseEventArgs e)
        {
            mouseIsDown = false;
            onLocationChange(e);
        }

        private void lblMain_MouseMove(object sender, MouseEventArgs e)
        {
            if (mouseIsDown)
            {
                // Get the difference between the two points
                int xDiff = firstPoint.X - e.Location.X;
                int yDiff = firstPoint.Y - e.Location.Y;

                // Set the new point
                int x = this.Location.X - xDiff;
                int y = this.Location.Y - yDiff;
                this.Location = new Point(x, y);
            }
        }

        private void lblCoold_Click(object sender, EventArgs e)
        {
            HkM.cooldownsOn = !HkM.cooldownsOn;
        }

        private void lblManual_Click(object sender, EventArgs e)
        {
            HkM.manualOn = !HkM.manualOn;
        }

        private void lblPreBuff_Click(object sender, EventArgs e)
        {
            HkM.preBuff = !HkM.preBuff;
        }

        private void lblAoE_Click(object sender, EventArgs e)
        {
            HkM.aoeOn = !HkM.aoeOn;
        }


        internal static void hideOverlay()
        {
            overlay.Hide();
            shown = false;
        }

        private void lblSEF_Click(object sender, EventArgs e)
        {
            HkM.SEF = !HkM.SEF;
        }
    }
}
