﻿using Monkee.Core.Managers;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using HkM = Monkee.Core.Managers.Hotkeys;
using M = Monkee.Main;
namespace Monkee.Interface.GUI
{
    public partial class frmSettings : Form
    {
        public Point overlayLocation { get; set; }
        public int modDown = 0;
        Dictionary<int, string> keys = new Dictionary<int, string>();
        Button currentButton;
        int currentHotkey;
        string oldButtonValue ="";
        Dictionary<int, string> dictModifs = new Dictionary<int, string>();
        public frmSettings()
        {
            InitializeComponent();
            dictModifs.Add(0, "");
            dictModifs.Add(1, "ALT");
            dictModifs.Add(2, "CTRL");
            dictModifs.Add(4, "SHIFT");
            ComponentResourceManager resrc = new ComponentResourceManager(typeof(frmSettings));
            this.picBoxBack.BackgroundImageLayout = System.Windows.Forms.ImageLayout.Stretch;
            
            bttnOverlay.Text = frmOverlay.isShown() ? "Close Overlay" : "Open Overlay";
            this.picBoxBack.BackgroundImage = ((System.Drawing.Image)(resrc.GetObject("imageBack")));
            loadSettings();

            
        }

        private void keyUp(object sender, KeyEventArgs e)
        {
            string keyComb = "";
            foreach (KeyValuePair<int, string> key in keys)
            {
                keyComb += key.Value + "+";
            }
            keyComb = keyComb.Length>0 ? keyComb.Substring(0, keyComb.Length - 1) : keyComb;
            keyComb = keyComb.Replace("Menu", "ALT");
            keyComb = keyComb.Replace("ShiftKey", "SHIFT");
            keyComb = keyComb.Replace("ControlKey", "CTRL");
            if ((keys.Count == 1 && keys.Last().Key <= 4) || keys.Count == 0)
            {
                currentButton.Text = oldButtonValue;
                keys.Clear();
                return;
            }
            switch (currentHotkey) { 
                case (int)Hotkey.AOE:
                    Main.Settings.hotkeyAOE = (keys.Count == 1) && (keys.Last().Key > 4) ? keys.Last().Key + "|0" : keys.Last().Key + "|" + keys.First().Key;
                    break;
                case (int)Hotkey.Burst:
                    Main.Settings.hotkeyBurst = (keys.Count == 1) && (keys.Last().Key > 4) ? keys.Last().Key + "|0" : keys.Last().Key + "|" + keys.First().Key;
                    break;
                case (int)Hotkey.Manual:
                    Main.Settings.hotkeyManual = (keys.Count == 1) && (keys.Last().Key > 4) ? keys.Last().Key + "|0" : keys.Last().Key + "|" + keys.First().Key;
                    break;
                case (int)Hotkey.PreBuff:
                    Main.Settings.hotkeyPreBuff = (keys.Count == 1) && (keys.Last().Key > 4) ? keys.Last().Key + "|0" : keys.Last().Key + "|" + keys.First().Key;
                    break;
                case (int)Hotkey.SEF:
                    Main.Settings.hotkeySEF = (keys.Count == 1) && (keys.Last().Key > 4) ? keys.Last().Key + "|0" : keys.Last().Key + "|" + keys.First().Key;
                    break;
            }

            currentButton.Text = keyComb;
            keys.Clear();
            currentButton.KeyDown -= keyDown;
            currentButton.KeyUp -= keyUp;
            Main.Settings.Save();
            HkM.removeHotkeys();
            HkM.registerHotKeys();
        }

        private void keyDown(object sender, KeyEventArgs e)
        {
            if (keys.Count >= 2 || (keys.Count == 1 && !(keys.ContainsValue("Menu") || keys.ContainsValue("ShiftKey") || keys.ContainsValue("ControlKey"))))
            {
                e.Handled = true;
                return;
            }
            if ((keys.ContainsValue("Menu") || keys.ContainsValue("ShiftKey") || keys.ContainsValue("ControlKey")) && (e.KeyCode == Keys.Menu || e.KeyCode == Keys.ShiftKey || e.KeyCode == Keys.ControlKey))
            {
                e.Handled = true;
                return;
            }
            int keyValue = e.KeyValue;
            if (e.KeyCode == Keys.Menu)
                keyValue = 1;
            else if (e.KeyCode == Keys.ControlKey)
                keyValue = 2;
            else if (e.KeyCode == Keys.ShiftKey)
                keyValue = 4;
            if (keys.Count != 0 && keys.Last().Key == e.KeyValue)
            {
                return;
            }
            else
            {
                keys.Add(keyValue, e.KeyCode.ToString());
            }
    
        }

        private void loadSettings()
        {
            numSEFMinHP.Value = Main.Settings.SEFMinHP;
            numSEFRange.Value = Main.Settings.SEFRange;
            numHTorHS.Value = Main.Settings.minHPtoUseHTorHS;
            KeysConverter kc = new KeysConverter();
            bttnAOE.Text = (dictModifs[HkM.getHotkey(M.Settings.hotkeyAOE).mod] != "" ? dictModifs[HkM.getHotkey(M.Settings.hotkeyAOE).mod] + "+" : "") + kc.ConvertToString(HkM.getHotkey(M.Settings.hotkeyAOE).key);
            bttnBurst.Text = (dictModifs[HkM.getHotkey(M.Settings.hotkeyBurst).mod] != "" ? dictModifs[HkM.getHotkey(M.Settings.hotkeyBurst).mod] + "+" : "") + kc.ConvertToString(HkM.getHotkey(M.Settings.hotkeyBurst).key);
            bttnManual.Text = (dictModifs[HkM.getHotkey(M.Settings.hotkeyManual).mod] != "" ? dictModifs[HkM.getHotkey(M.Settings.hotkeyManual).mod] + "+" : "") + kc.ConvertToString(HkM.getHotkey(M.Settings.hotkeyManual).key);
            bttnPreBuff.Text = (dictModifs[HkM.getHotkey(M.Settings.hotkeyPreBuff).mod] != "" ? dictModifs[HkM.getHotkey(M.Settings.hotkeyPreBuff).mod] + "+" : "") + kc.ConvertToString(HkM.getHotkey(M.Settings.hotkeyPreBuff).key);
            buttnSEF.Text = (dictModifs[HkM.getHotkey(M.Settings.hotkeySEF).mod] != "" ? dictModifs[HkM.getHotkey(M.Settings.hotkeySEF).mod] + "+" : "") + kc.ConvertToString(HkM.getHotkey(M.Settings.hotkeySEF).key);
        }

        private void bttnOverlay_Click_1(object sender, EventArgs e)
        {
            if (bttnOverlay.Text == "Open Overlay")
            {
                frmOverlay.showOverlay(overlayLocation);
                bttnOverlay.Text = "Close Overlay";
            }
            else
            {
                frmOverlay.hideOverlay();
                bttnOverlay.Text = "Open Overlay";
            }
        }

        private void numSEFRange_ValueChanged(object sender, EventArgs e)
        {
            Main.Settings.SEFRange = (int)numSEFRange.Value;
            Main.Settings.Save();
        }

        private void numSEFMinHP_ValueChanged(object sender, EventArgs e)
        {
            Main.Settings.SEFMinHP = (int)numSEFMinHP.Value;
            Main.Settings.Save();
        }

        private void numHTorHS_ValueChanged(object sender, EventArgs e)
        {
            Main.Settings.minHPtoUseHTorHS = (int)numHTorHS.Value;
            Main.Settings.Save();
        }

        private void bttnAOE_Click(object sender, EventArgs e)
        {
            currentButton = bttnAOE;
            oldButtonValue = currentButton.Text;
            currentButton.Text = "";
            currentButton.KeyDown += keyDown;
            currentButton.KeyUp += keyUp;
            currentHotkey = (int)Hotkey.AOE;
        }

        private void bttnBurst_Click(object sender, EventArgs e)
        {
            currentButton = bttnBurst;
            oldButtonValue = currentButton.Text;
            currentButton.Text = "";
            currentButton.KeyDown += keyDown;
            currentButton.KeyUp += keyUp;
            currentHotkey = (int)Hotkey.Burst;
        }

        private void bttnManual_Click(object sender, EventArgs e)
        {
            currentButton = bttnManual;
            oldButtonValue = currentButton.Text;
            currentButton.Text = "";
            currentButton.KeyDown += keyDown;
            currentButton.KeyUp += keyUp;
            currentHotkey = (int)Hotkey.Manual;
        }

        private void bttnPreBuff_Click(object sender, EventArgs e)
        {
            currentButton = bttnPreBuff;
            oldButtonValue = currentButton.Text;
            currentButton.Text = "";
            currentButton.KeyDown += keyDown;
            currentButton.KeyUp += keyUp;
            currentHotkey = (int)Hotkey.PreBuff;
        }

        private void buttnSEF_Click(object sender, EventArgs e)
        {
            currentButton = buttnSEF;
            oldButtonValue = currentButton.Text;
            currentButton.Text = "";
            currentButton.KeyDown += keyDown;
            currentButton.KeyUp += keyUp;
            currentHotkey = (int)Hotkey.SEF;
        }

        enum Hotkey{ 
            AOE,
            Burst,
            Manual,
            PreBuff,
            SEF
        }
    }
}
