﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using Styx.CommonBot.Routines;
using Styx;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;
using Styx.Common;
using Styx.CommonBot;
using CommonBehaviors.Actions;
using Monkee.Interface.GUI;
using System.Threading;
using System.Runtime.InteropServices;
using Monkee.Settings;
#region [Method] - Class Redundancy
using HKM = Monkee.Core.Managers.Hotkeys;
using R = Monkee.Rotation.Rotation;
using U = Monkee.Core.Unit;
using TM = Monkee.Core.Managers.initTMEvents;
using L = Monkee.Core.Utilities.Log;
using OV = Monkee.Interface.GUI.frmOverlay;
using System.IO;
#endregion  

namespace Monkee
{
    public class Main : CombatRoutine
    {
        public static readonly Version version = new Version(1, 0, 3);
        public override string Name { get { return "Monkee v" + version+"b"; } }
        public override WoWClass Class { get { return WoWClass.Monk; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        #region [Method] - Implementations
        public override Composite PreCombatBuffBehavior { get { return new ActionRunCoroutine(ctx => R.PreCombatCoRoutine()); } }
        public override Composite CombatBuffBehavior { get { return new ActionRunCoroutine(ctx => R.CombatBuffCoRoutine());  } }
        public override Composite CombatBehavior { get { return new ActionRunCoroutine(ctx => R.CombatCoRoutine()); } }
        private static MonkeeSettings _settings;
        public static MonkeeSettings Settings
        {
            get
            {
                return _settings ?? (_settings = new MonkeeSettings(CharacterSettingsPath));
            }
        }
        public static string CharacterSettingsPath
        {
            get
            {
                string dir = Path.Combine(Styx.Common.Utilities.AssemblyDirectory, "Settings", "Monkee");
                return Path.Combine(dir, StyxWoW.Me.Name, "Monkee" + ".xml");
            }
        }

        #region [Method] - Hidden Overrides
        public override void Initialize()
        {
            Logging.Write(Colors.OrangeRed, "Hello {0}!", Me.Specialization);
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.OrangeRed, "For optimal performance please use: Enyo");
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.OrangeRed, "Current Version:");
            Logging.Write(Colors.OrangeRed, "-- Monkee v" + version + "b --");
            Logging.Write(Colors.OrangeRed, "-- by deemon --");
            Logging.Write(Colors.OrangeRed, "-- A Monk CR --");
            BotEvents.OnBotStarted += BotEvents_OnBotStarted;
            BotEvents.OnBotStopped += BotEvents_OnBotStopped;
            Settings.Load();
            loadSettings();
            OV.onLocationChanged += OV_onLocationChanged;
            HKM.hotkeyStateChanged += HKM_hotkeyStateChanged;
            HKM.registerHotKeys();
        }

        private void loadSettings()
        {
            HKM.aoeOn = Settings.AOE;
            HKM.cooldownsOn = Settings.Burst;
            HKM.manualOn = Settings.Manual;
            HKM.preBuff = Settings.PreBuff;
            HKM.SEF = Settings.SEF;
        }

        private void HKM_hotkeyStateChanged(object sender, EventArgs e)
        {
            Settings.AOE = HKM.aoeOn;
            Settings.Burst = HKM.cooldownsOn;
            Settings.SEF = HKM.SEF;
            Settings.Manual = HKM.manualOn;
            Settings.PreBuff = HKM.preBuff;
            Settings.Save();
        }

        public void OV_onLocationChanged(object sender, EventArgs e)
        {
            if (OV.isShown())
            {
                Settings.OverlayX = OV.getLocation().X;
                Settings.OverlayY = OV.getLocation().Y;
                Settings.Save();
            }
        }

        private void BotEvents_OnBotStopped(EventArgs args)
        {
            OV.closeOverlay();
        }
        private void BotEvents_OnBotStarted(EventArgs args)
        {
            TM.setTalEvents();
            TM.initTalents();
            L.combatLog("Talents initializied");
        }

        private void TM_specChanged(object sender, EventArgs e)
        {
            BotManager.Current.Stop();
        }
        public override bool WantButton { get { return true; } }

        public override void OnButtonPress() {
            frmSettings sett = new frmSettings();
            sett.Text = "Settings -- Monkee v." + version+"b";
            if (Settings.OverlayX != 0 && Settings.OverlayY != 0)
                sett.overlayLocation = new System.Drawing.Point(Settings.OverlayX, Settings.OverlayY);
            sett.ShowDialog();
            
        }
        public override void ShutDown() { 
            HKM.removeHotkeys();
            if (OV.isShown())
            {
                Settings.OverlayX = OV.getLocation().X;
                Settings.OverlayY = OV.getLocation().Y;
                OV.closeOverlay();
                Settings.Save();
            }
        
        }
        #endregion  

        #region [Method] - Pulse
        public override void Pulse()
        {
            if (OV.isShown())
            {
                OV.updateLabels();
            }
            if (!StyxWoW.IsInWorld || Me == null || !Me.IsValid || !Me.IsAlive)
                return;
            if (Me.Specialization == WoWSpec.MonkBrewmaster || Me.Specialization == WoWSpec.MonkMistweaver)
            {
                L.combatLog("Current spec {0} is not supported yet. Do nothing.", Me.Specialization);
                return;
            }
            if (!Me.Combat)
                return;

            U.Cache();
            U.enemyAnnex(30);
        }
        #endregion 
        #endregion
    }
}
