﻿using Styx.Common;
using Styx.Helpers;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using DefaultValue = Styx.Helpers.DefaultValueAttribute;
namespace Monkee.Settings
{
    public class MonkeeSettings : Styx.Helpers.Settings
    {
        #region Constructor
        public MonkeeSettings ( string path) :  base(path) {

        }
        #endregion

        #region Overlay
        [Setting]
        [DefaultValue(100)]
        [CategoryAttribute("Overlay")]
        [DescriptionAttribute("Save Location.Y of the overlay on the screen.")]
        [DisplayName("OverlayX")]
        public int OverlayX{get;set;}

        [Setting]
        [DefaultValue(100)]
        [CategoryAttribute("Overlay")]
        [DescriptionAttribute("Save Location.Y of the overlay on the screen.")]
        [DisplayName("OverlayY")]
        public int OverlayY { get; set; }
        #endregion

        #region Hotkeys
        [Setting]
        [DefaultValue("81|1")]
        [CategoryAttribute("Hotkeys")]
        [DescriptionAttribute("Hotkey: AOE")]
        [DisplayName("AOE hotkey")]
        public string hotkeyAOE {get;set;}

        [Setting]
        [DefaultValue("69|1")]
        [CategoryAttribute("Hotkeys")]
        [DescriptionAttribute("Hotkey: Burst")]
        [DisplayName("Burst hotkey")]
        public string hotkeyBurst { get; set; }

        [Setting]
        [DefaultValue("83|1")]
        [CategoryAttribute("Hotkeys")]
        [DescriptionAttribute("Hotkey: Manual")]
        [DisplayName("Manual hotkey")]
        public string hotkeyManual { get; set; }

        [Setting]
        [DefaultValue("87|1")]
        [CategoryAttribute("Hotkeys")]
        [DescriptionAttribute("Hotkey: PreBuff")]
        [DisplayName("PreBuff hotkey")]
        public string hotkeyPreBuff { get; set; }

        [Setting]
        [DefaultValue("65|1")]
        [CategoryAttribute("Hotkeys")]
        [DescriptionAttribute("Hotkey: SEF")]
        [DisplayName("SEF hotkey")]
        public string hotkeySEF { get; set; }

        [Setting]
        [DefaultValue(false)]
        [CategoryAttribute("Hotkeys")]
        [DescriptionAttribute("Hotkey state: AOE")]
        [DisplayName("AOE")]
        public bool AOE { get; set; }

        [Setting]
        [DefaultValue(false)]
        [CategoryAttribute("Hotkeys")]
        [DescriptionAttribute("Hotkey state: Burst")]
        [DisplayName("Burst")]
        public bool Burst { get; set; }

        [Setting]
        [DefaultValue(false)]
        [CategoryAttribute("Hotkeys")]
        [DescriptionAttribute("Hotkey state: Manual")]
        [DisplayName("Manual")]
        public bool Manual { get; set; }

        [Setting]
        [DefaultValue(false)]
        [CategoryAttribute("Hotkeys")]
        [DescriptionAttribute("Hotkey state: PreBuff")]
        [DisplayName("PreBuff")]
        public bool PreBuff { get; set; }

        [Setting]
        [DefaultValue(false)]
        [CategoryAttribute("Hotkeys")]
        [DescriptionAttribute("Hotkey state: SEF")]
        [DisplayName("SEF")]
        public bool SEF { get; set; }
        #endregion

        #region Windwalker
        [Setting]
        [DefaultValue(40)]
        [CategoryAttribute("Windwalker")]
        [DescriptionAttribute("SEF Maximum Range")]
        [DisplayName("SEF Range")]
        public int SEFRange { get; set; }

        [Setting]
        [DefaultValue(200000)]
        [CategoryAttribute("Windwalker")]
        [DescriptionAttribute("SEF Min HP Requirement")]
        [DisplayName("SEF Min HP")]
        public int SEFMinHP { get; set; }
        #endregion 

        #region General
        [Setting]
        [DefaultValue(30)]
        [CategoryAttribute("General")]
        [DescriptionAttribute("Healing Tonic or Healthstone usage on lower hp % than")]
        [DisplayName("HT or HS use")]
        public int minHPtoUseHTorHS { get; set; }
        #endregion


        #region Enums

        #endregion
    }
}
